#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

// Make a modifiable string that's a copy of the input string
char* make_mutable_string(const char* input_str) {
    // determine how long the input is
    size_t string_length = strlen(input_str);

    // allocate memory for a new string
    char* output_str = (char*)malloc(string_length + 1);
    if (output_str == NULL) {
        printf("ERROR! Malloc failed\n");
        exit(1);
    }

    // copy over characters
    for (int i=0; input_str[i] != '\0'; i++) {
        output_str[i] = input_str[i];
    }
    output_str[string_length] = '\0';

    // return newly created string
    return output_str;
}

// Make every character of the string uppercase
void uppercase_string(char* mutable_str) {
    // make each character uppercase
    for (int i=0; mutable_str[i] != '\0'; i++) {
        mutable_str[i] = toupper(mutable_str[i]);
    }
}


// Print the string and then free its memory
void print_and_destroy(char* mutable_str) {

    // print string
    printf("%s\n", mutable_str);

    // free memory
    free(mutable_str);
}


int main(void) {

    char* mutable_str = make_mutable_string("Lazy brown fox blah blah blah");

    uppercase_string(mutable_str);

    print_and_destroy(mutable_str);

    return 0;
}

